//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 06: OpenMp
//
//  Description: Sort using openMP. Just Create the Array of short int random numbers
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc ompSort01.c -o ompSort01 -fopenmp -O2
Executing:	./ompSort01

Output in my Laptop:
17767 9158 43069 58067 64412 51870 56409 55395

real	0m0.012s
user	0m0.008s
sys	0m0.004s

*/
//************************************************************


// *******************************************************************
#pragma GCC optimize("O3","unroll-loops","omit-frame-pointer","inline")
#pragma GCC option("arch=native","tune=native","no-zero-upper")
//************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <omp.h>


// Array Size
#define N          100000

unsigned short int A[N] ;

// ***************************************
unsigned long createArray( void )
{
for (unsigned int i=0 ; i < N ; i++ )
	A[i] = rand() ;
//	A[i] = rand() % 65536 ;
}


// ***************************************
void PrintResults()
{
for( unsigned int i = 0 ; i < N ; i++ )
	printf( "%hu ", A[i]) ;
putchar('\n') ;
}


// ***************************************
int main()
{

createArray() ;
printf( "%hu %hu %hu %hu ",  A[0], A[1], A[N/4], A[N/3] ) ;
printf( "%hu %hu %hu %hu\n", A[N/2], A[2*N/3], A[3*N/4], A[N-1] ) ;
return 0 ;
}
