//************************************************************
//  University of Patras
//	Department of Electrical Engineering & Computer Technology
//
//	Course: Parallel Programming in AI
//	Week 05: OpenMp
//
//  Description: Sort using openMP. Serial Pair Sort
//	Author: Evangelos Dermatas
//	v0.1
/*
*********************************************************************
gcc -v:	gcc version 7.4.0 (Ubuntu 7.4.0-1ubuntu1~18.04.1)
OS: 	Linux Ubuntu 18.04
CPU:	8-core, Intel(R) Core(TM) i7-2630QM CPU @ 2.00GHz, 3991 BogoMips
*********************************************************************
Compiling:	gcc ompSort04.c -o ompSort04 -fopenmp
Executing:	./ompSort04

FOR N=100000
Output in my Laptop:
0 0 16331 21720 32534 43513 48959 65535

real	0m9.523s
user	0m9.512s
sys	0m0.008s

*/
//************************************************************


// *******************************************************************
//#pragma GCC optimize("O3","unroll-loops","omit-frame-pointer","inline")
//#pragma GCC option("arch=native","tune=native","no-zero-upper")
//************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <omp.h>


// Array Size
#define N          100000

unsigned short int A[N] ;

// ***************************************
unsigned long createArray( void )
{
for (unsigned int i=0 ; i < N ; i++ )
	A[i] = rand() % 65536 ;
}


// ***************************************
void PrintResults()
{
for( unsigned int i = 0 ; i < N ; i++ )
	printf( "%hu ", A[i]) ;
putchar('\n') ;
}

// ***************************************
void PairSort()
{
char c ;
do {
	c = 0 ;
	for( unsigned int j = 0 ; j < N ; j+=2 )
		if ( A[j] > A[j+1] ) {
		unsigned short k= A[j] ;
		A[j]=A[j+1] ;
		A[j+1]=k ;
		c = 1 ;
		}

	for( unsigned int j = 1 ; j < N-1 ; j+=2 )
		if ( A[j] > A[j+1] ) {
		unsigned short k= A[j] ;
		A[j]=A[j+1] ;
		A[j+1]=k ;
		c = 1 ;
		}
} while(c) ;
}


// ***************************************
int main()
{

createArray() ;

	PairSort() ;

printf( "%hu %hu %hu %hu ",  A[0], A[1], A[N/4], A[N/3] ) ;
printf( "%hu %hu %hu %hu\n", A[N/2], A[2*N/3], A[3*N/4], A[N-1] ) ;
return 0 ;
}
